
        xdef	        _main
	xdef		_comment
	include		"flib.h"	;Well needed to clear screen
	include		"tios.h"	;Needed to locate LCD memory

;************** Start of Fargo program **************

_main:

	jsr		flib::clr_scr	;clear screen

	;BASIC ALGORITHM :
;x = 0
;y = radius
;switch = 3 - 2*radius
;loop:

        ;plot (x,y); plot (x,-y); plot (-x,y); plot (-x,-y)
        ;plot (y,x); plot (y,-x); plot (-y,x); plot (-y,-x)

   ;if switch < 0 then
;            switch = switch + 4 * x + 6        
   ;else
;            switch = switch + 4 * (x - y) + 10            
;	     y = y - 1
   ;endif

   ;x = x + 1
   ;if x <= y then goto loop
;end


;registers d0-d6/a0 are destroyed by this function (could be pushed/poped ?)
	lea	LCD_MEM,a0        

;	move.w	#12050,d4		;d0 = Pxl = Center + 240*Yvar
	move.w	#24051,o1
	move.w	#00051,o2
	move.w	#00051,o3
	move.w	#24051,o4
	move.w	#12101,o5
	move.w	#12001,o6
	move.w	#12001,o7
	move.w	#12101,o8
	move.w	#0,d1			;d1 = Xvar = 0
	move.w	#50,d2			;d2 = Yvar = Ray
	move.w	#-97,d3 		;d3 = var = 3 - 2*Ray

@@Circle:
	move.w		o1,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o2,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o3,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o4,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o5,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o6,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o7,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel

	move.w		o8,d0		;Here we go
	move.w		d0,d5		; pixel plotting mechanism I could explain if anyone wants
	neg		d0		; to ...
	and.w		#7,d0		; just mail me at Yves.Rollet@wanadoo.fr
	subq		#1,d5		; or drop a line on ICQ 8645588
	lsr.w		#3,d5		; also get more details at http://titools.home.ml.org
	bset.b		d0,0(a0,d5)	; plotting pixel


	or.w		d3,d3		;Test d3's sign
	bpl		@@CElse		;If Neg-Flag set -> jump to @@CEsle
	move.w		d1,-(sp)	;Push X
	lsl.w		#2,d1		;4*X -> X
;	muls		#30,d1
	add.w		d1,d3		;4X + var -> var
	add.w		#6,d3		;6 + var -> var ==> var = 4X + var + 6
	move.w		(sp)+,d1	;Pop X
	bra		@@CEnd		;Jump to @@CEnd

@@CElse:
	move.w		d1,-(sp)	;Push X
	sub.w		d2,d1		;X - Y
	lsl.w		#2,d1		;4 * (X - Y)
	add.w		d1,d3		;4(X - Y) + var -> var
	add.w		#10,d3		;10 + var -> var ==> var = 4(X - Y) + 10 + var
	move.w		(sp)+,d1	;Pop X
	sub.w		#240,o1		;Next line
	sub.w		#240,o4
	subq		#1,o5
	subq		#1,o8
	add.w		#240,o2
	add.w		#240,o3
	addq		#1,o6
	addq		#1,o7
	subq		#1,d2		;Y - 1 -> Y

@@CEnd:
	addq		#1,d1		;X + 1 -> X
	addq		#1,o1		;Next pixel
	subq		#1,o4
	add.w		#240,o5
	sub.w		#240,o8
	subq		#1,o2
	addq		#1,o3
	sub.w		#240,o6
	add.w		#240,o7

	cmp.w		d2,d1		;if X <= y then goto @@Circle
	ble		@@Circle

	jsr		flib::idle_loop	;Wait until a key is pressed


	rts

;*****************************************************

;*****************************************************

xincr		dc.w 1			;Var for the long-way incrementation
yincr		dc.w 240		;Var for the short-way incrementation
deltay2		dc.w 0			;2 * DeltaY
deltay_x2	dc.w 0			;2 * (DeltaX - DeltaY)

o1		dc.w 0
o2		dc.w 0
o3		dc.w 0
o4		dc.w 0
o5		dc.w 0
o6		dc.w 0
o7		dc.w 0
o8		dc.w 0

;****************************************************
_comment:
        dc.b    "Jerbom's Bresenham circle",0
;************** End of Fargo program ****************

 
        end